<?php
// $Id: photos.admin.inc,v 1.1.2.12 2008/12/20 05:47:20 eastcn Exp $
function photos_admin_settings() {
	$form['one'] = array(
		'#title' => t('Basic settings'),
		'#weight' => -4,
		'#type' => 'fieldset',
		'#collapsible' => TRUE,
	);
	$form['two'] = array(
		'#title' => t('Advanced Settings'),
		'#weight' => -3,
		'#type' => 'fieldset',
		'#collapsible' => TRUE,
	);
	$form['photos_swfu'] = array(
		'#title' => t('Photos swfu'),
		'#weight' => -2,
		'#type' => 'fieldset',
		'#collapsible' => TRUE,
	);
	$form['one']['photos_num'] = array(
		'#type' => 'select',
		'#title' => t('Number of upload'),
		'#default_value' => variable_get('photos_num', 5),
		'#options' => drupal_map_assoc(array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)),
		'#description' => t('Maxium amount allowed for one upload'),
	);
	$form['one']['photos_pnum'] = array(
		'#type' => 'textfield',
		'#title' => t('Number of albums'),
		'#default_value' => variable_get('photos_pnum', 20),
		'#description' => t('The number of albums a user allowed to create. Administrater is not limited.'),
    '#size' => 20
	);
	$form['one']['photos_t_w'] = array(
		'#type'=> 'textfield',
		'#title' => t('Thumbnail size'),
		'#default_value' => variable_get('photos_t_w', '100x100'),
		'#description' => t('This photos module creates 2 formats of thumbnails, and saves original image. Please set size'),
		'#size' => '10',
	);

	$form['one']['photos_t_s'] = array(
		'#type' => 'select',
		'#title' => t('Thumbnail format'),
		'#default_value' => variable_get('photos_t_s', 'crop'),
		'#options' => array('scale' => 'scale','crop' => 'crop'),
		'#description' => t('scale: Keep ratio for resizing, crop:  Fix size, aligned by a border.'),
	);
	$form['one']['photos_t_ww'] = array(
		'#type'=> 'textfield',
		'#title' => t('Medium image size'),
		'#default_value' => variable_get('photos_t_ww', '640x480'),
		'#description' => t('This photos module creates 2 formats of thumbnails, and saves original image. Please set size'),
		'#size' => '10',
	);
	$form['one']['photos_t_ss'] = array(
		'#type' => 'select',
		'#title' => t('Medium image format'),
		'#default_value' => variable_get('photos_t_ss', 'scale'),
		'#options' => array('scale' => 'scale','crop' => 'crop'),
		'#description' => t('scale: Keep ratio for resizing, crop:  Fix size, aligned by a border.'),
	);
	$form['one']['photos_path'] = array(
		'#type'=> 'textfield',
		'#title' => t('Path of saving'),
		'#default_value' => variable_get('photos_path', 'photos/image_%uid'),
		'#description' => t('The path where the files should be saved, may save by user id or user name or time, e.g.: photos/%uid or photos/%username or image/%Y/%m/%d. Available variables: %uid, %username, %Y, %m, %d.'),
		'#size' => '40',
		'#required' => TRUE,
	);
  
	$form['one']['photos_open_orig'] = array(
		'#type' => 'radios',
		'#title' => t('Open original Images in a new window?'),
		'#default_value' => variable_get('photos_open_orig', 0),
		'#description' => t('If this option is enabled, the original images will be opened in a new browser window instead of being displayed inside the site'),
		'#options' => array(t('Disabled'), t('Enabled')),
	);

	$form['two']['photos_access_photos'] = array(
		'#type' => 'radios',
		'#title' => t('privacy settings'),
		'#default_value' => variable_get('photos_access_photos', 0),
		'#description' => t('This option is enabled, users will be able to album set to confidentiality'),
		'#options' => array(t('Disabled'), t('Enabled')),
    '#disabled' => (module_exists('photos_access') ? false: true)
	);
  
	$form['two']['photos_privacy_default'] = array(
		'#type' => 'textfield',
		'#title' => t('Default image'),
		'#default_value' => variable_get('photos_privacy_default', false),
		'#description' => t('Show no permission to display the image'),
    '#disabled' => (module_exists('photos_access') ? false: true)
	);
  
	$form['two']['photos_upzip'] = array(
		'#type' => 'radios',
		'#title' => t('zip compressed upload'),
		'#default_value' => variable_get('photos_upzip', 0),
		'#description' => t('Will be allowed to upload images compressed into a zip, extract the necessary support to open php'),
		'#options' => array(t('Disabled'), t('Enabled')),
	);
	$form['two']['photos_rname'] = array(
		'#type' => 'radios',
		'#title' => t('Rename image'),
		'#default_value' => variable_get('photos_rname', 0),
		'#description' => t('Rename uploaded image by random numbers, to solve problems with non-ASCII filenames such as Chinese.'),
		'#options' => array(t('Disabled'), t('Enabled')),
	);
	$form['two']['photos_exif'] = array(
		'#type' => 'radios',
		'#title' => t('Show exif information'),
		'#default_value' => variable_get('photos_exif', 0),
		'#description' => t('When the image is available exif information, automatically read and display. Open this option, you must load the php exif.'),
		'#options' => array(t('Disabled'), t('Enabled')),
	);
  if(variable_get('comment_photos', COMMENT_NODE_READ_WRITE) == 2){
    $commenttrue = true;
  }
	$form['two']['photos_comment'] = array(
		'#type' => 'radios',
		'#title' => t('Comment setting'),
		'#default_value' => variable_get('photos_comment', 0),
		'#description' => t('Open for the photo comments, you must first type of content in the overall set of options open comments.'),
		'#options' => array(t('Disabled'), t('Enabled')),
    '#disabled' => ($commenttrue ? false: true)
	);
	$form['two']['photos_vote'] = array(
		'#type' => 'radios',
		'#title' => t('Images vote'),
		'#default_value' => variable_get('photos_vote', 0),
		'#description' => t('For the image to increase the voting feature, you must first install the votingapi.module.'),
		'#options' => array(t('Disabled'), t('Enabled')),
		'#disabled' => (module_exists('votingapi') ? false: true)
	);
	$form['two']['photos_image_count'] = array(
		'#type' => 'radios',
		'#title' => t('Count image views'),
		'#default_value' => variable_get('photos_image_count', 0),
		'#description' => t('Increment a counter each time image is viewed.'),
		'#options' => array( t('Enabled'), t('Disabled'))
	);
  $swfurl = drupal_get_path(module,photos).'/flash_gallery/gallery.swf';
	$form['two']['photos_flash'] = array(
		'#type' => 'radios',
		'#title' => t('FLASH slide show'),
		'#default_value' => variable_get('photos_flash', 0),
		'#description' => t('Please download <a href="@url">dfgallery</a>, and save to flash_gallery under , e.g: @swfurl',array('@url' => url('http://www.dezinerfolio.com/2007/06/07/dfgallery/'), '@swfurl' => $swfurl)),
		'#options' => array(t('Disabled'), t('Enabled')),
    '#disabled' => (file_exists($swfurl) ? false: true)
	);
	$form['two']['photos_flash_zoom'] = array(
		'#type'=> 'textfield',
		'#title' => t('Flash width and height'),
		'#default_value' => variable_get('photos_flash_zoom', '500x450'),
		'#description' => t('The width and length of flash, e.g: 500x450.'),
		'#size' => '20',
    '#disabled' => (file_exists($swfurl) ? false: true)
	);
  
	$form['two']['photos_flash_show'] = array(
		'#type' => 'radios',
		'#title' => t('FLASH show image size'),
		'#default_value' => variable_get('photos_flash_show', 0),
		'#options' => array(t('Medium image size'), t('Original Size')),
    '#disabled' => (file_exists($swfurl) ? false: true)
	);
  
	$form['photos_swfu']['photos_swfu_num'] = array(
		'#type' => 'select',
		'#title' => t('Number of upload'),
		'#default_value' => variable_get('photos_swfu_num', 100),
		'#options' => drupal_map_assoc(array(1, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100)),
		'#description' => t('Maxium amount allowed for one upload'),
    '#disabled' => (module_exists('photos_swfu') ? false: true)
	);

	return system_settings_form($form);
}

function photos_admin_update(&$form_state){
  $form['photos_update'] = array(
    '#type' => 'checkbox',
    '#title' => t('Thumbnail-size bulk update'),
    '#description' => t('Normally, you do not need to update it.'),
  );
  $form['submit'] = array(
  	'#type' => 'submit',
  	'#value' => t('Confirm'),
  );
  $form['#validate'][] = 'photos_admin_update_validate';
  return $form;
}

function photos_admin_update_validate($form, & $form_state){
  if($form_state['values']['photos_update']){
    $result = db_query('SELECT f.filepath FROM {files} f INNER JOIN {x_image} i ON f.fid = i.fid');
    $i = 0;
    while ($a = db_fetch_object($result)) {
      $t = end(explode('/', $a->filepath));
      $path = str_replace($t,'',$a->filepath);
      _photos_image_crop($a->filepath, $path);
      $i++;
    };
    if($i){
      drupal_set_message(t('Update the %num images.', array('%num' => $i)));
    }
  }
}